// The facet satcomPreprocessor takes the control signals and the received signal
//as the input .As the suncronizer has no condition , the clock is changed in the next state
// The detector also has no condition and so the bit is always detected in the next state.
//ASSUMPTIONS:It is assumed that the syncronizer and the detector components have an unimplemented 
//functions which synchronize and detect the bits.
//The uniqueWordDetect control bit is disabled when the  finish bit is enabled .

use signalTypes;

facet satcomPreprocessor (uniqueWordDetect,acquisitionLost,newBurst :: in
bit;inSignal :: in signal;finish,output:: out bit) is
	
	resetSync,reset,valueBit:: bit ;
	clockSignal::squareSignal;
	count::integer;
	
begin state_based 

	resetsync: resetSync = %(%acquisitionLost or %newBurst);

	synchronize: synchronizer(inSignal,clockSignal,resetSync);

	detect : detector(inSignal,clockSignal,valueBit);

	uniqueWord: %uniqueWordDetect   => counter(count,finish)
and uniqueWordDetector(valueBit,count,finish,output);	

end satcomPreprocessor;

	 	
