// The facet uniqueWordDetector is a component that detects the unique
// word by comparing the incoming bit to the expected one and the
// corelation is  taken.If the count is equal to the maximum count then
// the finish bit is 1 .This is to inform the counter to reset the count

facet uniqueWordDetector(inBit :: in bit;count:: in
integer;finish::inout bit;output:: out bit) is

	uniqueWord:: array(bit);
	corelationScore:: integer;
	increment(x::integer)::integer is x + 1;
	decrement(x::integer)::integer is x - 1;

begin state_based

	l1: if (count == 148) 
		then (if (corelationScore < 17)
			  then output' =0
			  else output' =1
			  endif)
			 and finish' =1 
		else finish' =0
			 and 
		     (if (uniqueWord[count] == inBit) 
			then corelationScore' = increment(corelationScore)
			else corelationScore' = decrement(corelationScore)
		      endif)
	    endif;

end uniqueWordDetector;  
